

C64      = 1
C128     = 0


SETLFS   = $FFBA
SETNAM   = $FFBD
OPEN     = $FFC0
CHKIN    = $FFC6
CHKOUT   = $FFC9
CHRIN    = $FFCF
CHROUT   = $FFD2
READST   = $FFB7
CLOSE    = $FFC3
CLRCHN   = $FFCC
GETIN    = $FFE4
CLALL    = $FFE7
IOINIT   = $FF84
FA       = $BA


         .IF C64
BLNSW    = $CC
BLNON    = $CF


SLIDEBEG = $4F
SLIDEEND = $CF

INCHRBEG = $2E
INCHREND = $4F


CLTABL   = $2300
LLTABL   = CLTABL
DISTABL  = CLTABL+$0120

CLTAB    = CLTABL+$0200
LLTAB    = CLTAB
DISTAB   = LLTABL


CRCT0    = $2A00 ;CLTABL+$700
CRCT1    = $2B00
CRCT2    = $2C00
CRCT3    = $2D00

CRC0     = $3B
CRC1     = $3C
CRC2     = $3D
CRC3     = $3E


INCHRI   = $3F ;$40
INCHRO   = $41 ;$42
INCHRTMP = $67       ;WAS$02

INBYTE   = $68
BP       = $69
TEMP     = $6A  ;,B,C,D
DEST     = $6E  ;,F


IOZP     = $70


LEN      = $F7
LLP      = $F9
SLIDE    = $FB
SLIDEC   = $FD
         .ENDIF


         .IF C128
SETBNK   = $FF68
INDFET   = $FF74
INDSTA   = $FF77

MODE     = $D7

BLNSW    = $0A27
BLNON    = $0A26
CURMOD   = $0A2B
STAVEC   = $02B9


SLIDEBEG = $40
SLIDEEND = $C0

INCHRBEG = $04  ;$13
INCHREND = $FF  ;$1C


CLTABL   = $3900
LLTABL   = CLTABL
DISTABL  = CLTABL+$0120

CLTAB    = CLTABL+$0200
LLTAB    = CLTAB
DISTAB   = LLTABL

CRCT0    = $0C00 ;CLTABL+$700
CRCT1    = $0D00
CRCT2    = $0E00
CRCT3    = $0F00


CRC0     = $83
CRC1     = $84
CRC2     = $85
CRC3     = $86

INCHRI   = $87          ;$3F ;+1
INCHRO   = $89          ;$41 ;+1
INCHRTMP = $8B          ;$67

INBYTE   = $8C          ;$68
BP       = $8D          ;$69

TEMP     = $C8          ;+3 *

DEST     = $8E          ;$6E  ;+1

IOZP     = $A6          ;+1 *

LEN      = $AA          ;+1 *
LLP      = $B5          ;$F9 ;+1

SLIDE    = $FB
SLIDEC   = $FD

         .ENDIF






         .IF C64
         *= $0800
         ;1999 SYS2078:REM...TROBE
         .BYTE $00,$1C,$08,$D0
         .BYTE $07,$9E,$32,$30
         .BYTE $37,$38,$3A,$8F
         .BYTE $14,$14,$14,$14
         .BYTE $14,$14,$14,$14
         .BYTE $14,$14,$54,$52
         .BYTE $4F,$42,$45,$00
         .BYTE $00,$00

         LDA $01
         AND #$7E
         STA $01
         .ENDIF


         .IF C128
         *= $1C00
        ;1999 GRAPHICCLR:SYS7201:REM..
         .BYTE $00,$1F,$1C,$D0
         .BYTE $07,$DE,$9C,$3A
         .BYTE $9E,$37,$32,$30
         .BYTE $31,$3A,$8F,$1B
         .BYTE $50,$1B,$4A,$31
         .BYTE $39,$39,$39,$20
         .BYTE $53,$54,$52,$4F
         .BYTE $42,$45,$00,$00
         .BYTE $00

         LDA #$0E  ;RAM0,KERNAL,IO
         STA $FF00

         LDA #$00
         TAX
         JSR SETBNK

         LDY #$11
FNCTN1   LDA $1000,Y
         STA $10EC,Y
         LDA PFK128,Y
         STA $1000,Y
         DEY
         BPL FNCTN1
         .ENDIF



         ;SCPU OPTIMIZE
         STA $D07E
         STA $D076
         STA $D07F

         LDA FA
         CMP #$08
         BCS *+4
         LDA #$08
         STA SRCDEV
         STA DESTDEV

        ;CRC TABLES
         LDY #0
MAKECRC0 STY CRC0
         LDA #0
         STA CRC1
         STA CRC2
         STA CRC3

         LDX #7
MAKECRC1 LSR CRC3
         ROR CRC2
         ROR CRC1
         ROR CRC0
         BCC MAKECRC2

         LDA CRC0
         EOR #$20
         STA CRC0
         LDA CRC1
         EOR #$83
         STA CRC1
         LDA CRC2
         EOR #$B8
         STA CRC2
         LDA CRC3
         EOR #$ED
         STA CRC3

MAKECRC2 DEX
         BPL MAKECRC1

         LDA CRC0
         STA CRCT0,Y
         LDA CRC1
         STA CRCT1,Y
         LDA CRC2
         STA CRCT2,Y
         LDA CRC3
         STA CRCT3,Y
         INY
         BNE MAKECRC0


MENU     LDA #0
         STA $D020
         STA $D021
         STA IONUM
         STA IONUM+1
         STA IONUM+2
         STA IONUM+3
         LDY ZIPNAMEL
         STA ZIPNAME,Y
         LDY ZIPPATHL
         STA ZIPPATH,Y
         LDY FILEPTHL
         STA FILEPTH,Y
         LDA #""
         JSR CHROUT
         LDA #14
         JSR CHROUT
         LDA #8
         JSR CHROUT

MENU1    LDX #<TXTM1
         LDY #>TXTM1
         JSR IOPRINT
         LDA SRCDEV
         STA IONUM
         JSR IOPRND

         LDX #<TXTM2
         LDY #>TXTM2
         JSR IOPRINT
         LDX #<ZIPPATH
         LDY #>ZIPPATH
         JSR IOPRINT

         LDX #<TXTM3
         LDY #>TXTM3
         JSR IOPRINT
         LDA DESTDEV
         STA IONUM
         JSR IOPRND

         LDX #<TXTM4
         LDY #>TXTM4
         JSR IOPRINT
         LDX #<FILEPTH
         LDY #>FILEPTH
         JSR IOPRINT





         LDX #<TXTM5
         LDY #>TXTM5
         JSR IOPRINT

         LDX #<ZIPNAME
         LDY #>ZIPNAME
         JSR IOPRINT

         LDX #<TXTM6
         LDY #>TXTM6
         JSR IOPRINT
         LDA FILETYPD
         JSR CHROUT

         LDX #<TXTM7
         LDY #>TXTM7
         JSR IOPRINT

         LDX #<TXTM8
         LDY #>TXTM8
         JSR IOPRINT



MENUIN   JSR GETIN
         BEQ MENUIN

MENUF1   CMP #133
         BNE MENUF2
         LDA #""
         JSR CHROUT
         LDA #$24
         STA IOTEXT
         LDX #0
         LDY #1
MENUF1A  CPX ZIPPATHL
         BEQ MENUF1B
         LDA ZIPPATH,X
         STA IOTEXT,Y
         INX
         INY
         BPL MENUF1A
MENUF1B  LDA #$2A
         STA IOTEXT,Y
         INY
         LDX SRCDEV
         JSR IODIR
         JMP MENU

MENUF2   CMP #137
         BNE MENUF3
MENUF2A  INC SRCDEV
         LDX SRCDEV
         CPX #31
         BEQ MENUF2B
         JSR IOPING
         BMI MENUF2A
         JMP MENU1
MENUF2B  LDX #8
         STX SRCDEV
         JMP MENU1

MENUF3   CMP #134
         BNE MENUF4
         LDA #""
         JSR CHROUT
         LDA #$24
         STA IOTEXT
         LDX #0
         LDY #1
MENUF3A  CPX FILEPTHL
         BEQ MENUF3B
         LDA FILEPTH,X
         STA IOTEXT,Y
         INX
         INY
         BPL MENUF3A
MENUF3B  LDA #$2A
         STA IOTEXT,Y
         INY
         LDX DESTDEV
         JSR IODIR
         JMP MENU

MENUF4   CMP #138
         BNE MENUF5
MENUF4A  INC DESTDEV
         LDX DESTDEV
         CPX #31
         BEQ MENUF4B
         JSR IOPING
         BMI MENUF4A
         JMP MENU1
MENUF4B  LDX #8
         STX DESTDEV
         JMP MENU1

MENUF5   CMP #135
         BNE MENUF6
         LDX #<TXTMA
         LDY #>TXTMA
         JSR IOPRINT
         JSR IOINPUT
         CPY #$00
         BNE MENUF5A
         JSR SLCT
         CPY #$00
         BNE MENUF5A
         JMP MENU
MENUF5A  STY ZIPNAMEL
MENUF5B  LDA IOTEXT,Y
         STA ZIPNAME,Y
         DEY
         BPL MENUF5B
         JMP MENU

MENUF6   CMP #139
         BNE MENUF7
         LDA FILETYPD
         EOR #$03
         STA FILETYPD
         JMP MENU1

MENUF7   CMP #136
         BNE MENUF8
         JSR UNZIP
         JSR IOPAUSE
         JMP MENU

MENUF8

MENUPLUS CMP #"+"
         BNE MENUMIN
         LDX #<TXTMB
         LDY #>TXTMB
         JSR IOPRINT
         JSR IOINPUT
         STY ZIPPATHL
MENUPLU1 LDA IOTEXT,Y
         STA ZIPPATH,Y
         DEY
         BPL MENUPLU1
         JMP MENU

MENUMIN  CMP #"-"
         BNE MENUAT
         LDX #<TXTMC
         LDY #>TXTMC
         JSR IOPRINT
         JSR IOINPUT
         STY FILEPTHL
MENUMIN1 LDA IOTEXT,Y
         STA FILEPTH,Y
         DEY
         BPL MENUMIN1
         JMP MENU

MENUAT   CMP #"@"
         BEQ *+5
         JMP MENUSTAR
         LDA SRCDEV
         TAX
         LDY #$0F
         JSR SETLFS

         LDA #0
         JSR SETNAM
         JSR OPEN

         LDX SRCDEV
         JSR IOERROR
         LDA IOERRNUM
         BNE MENUAT3

         ;SET PARTITION
         JSR SRCDRIVE
         LDX SRCDEV
         JSR DRVPART

         LDA SRCDEV
         STA IONUM
         JSR IOPRND

         LDA DRIVE
         BEQ MENUAT00
         LDA #","
         JSR CHROUT
         LDX #<DRIVE
         LDY #>DRIVE
         JSR IOPRINT

MENUAT00 LDX #<TXTMD
         LDY #>TXTMD
         JSR IOPRINT
         JSR IOINPUT
         CPY #$00
         BEQ MENUAT2
         LDX SRCDEV
         LDA IOTEXT
         CMP #"$"
         BNE MENUAT0
         JSR IODIR
         JMP MENUAT4
MENUAT0  JSR CHKOUT
         LDX #$00
MENUAT1  LDA IOTEXT,X
         JSR CHROUT
         INX
         DEY
         BNE MENUAT1
         LDA #$0D
         JSR CHROUT

         JSR CLRCHN

         LDA #$0D
         JSR CHROUT
MENUAT2  LDX SRCDEV
         JSR IOERROR
MENUAT3  LDX #<IOTEXT
         LDY #>IOTEXT
         JSR IOPRINT
         LDA #$0D
         JSR CHROUT
         JSR IOPAUSE
MENUAT4  LDA SRCDEV
         JSR CLOSE
         JMP MENU

MENUSTAR CMP #"*"
         BEQ *+5
         JMP MENURST
         LDA DESTDEV
         TAX
         LDY #$0F
         JSR SETLFS
         LDA #0
         JSR SETNAM
         JSR OPEN


         LDX DESTDEV
         JSR IOERROR
         LDA IOERRNUM
         BNE MENUST3

         ;SET PARTITION
         JSR DSTDRIVE
         LDX DESTDEV
         JSR DRVPART

         LDA DESTDEV
         STA IONUM
         JSR IOPRND

         LDA DRIVE
         BEQ MENUST00
         LDA #","
         JSR CHROUT
         LDX #<DRIVE
         LDY #>DRIVE
         JSR IOPRINT

MENUST00 LDX #<TXTMD
         LDY #>TXTMD
         JSR IOPRINT
         JSR IOINPUT
         CPY #$00
         BEQ MENUST2
         LDX DESTDEV
         LDA IOTEXT
         CMP #"$"
         BNE MENUST0
         JSR IODIR
         JMP MENUST4
MENUST0  JSR CHKOUT
         LDX #$00
MENUST1  LDA IOTEXT,X
         JSR CHROUT
         INX
         DEY
         BNE MENUST1
         LDA #$0D
         JSR CHROUT
         JSR CLRCHN
         LDA #$0D
         JSR CHROUT
MENUST2  LDX DESTDEV
         JSR IOERROR
MENUST3  LDX #<IOTEXT
         LDY #>IOTEXT
         JSR IOPRINT
         LDA #$0D
         JSR CHROUT
         JSR IOPAUSE
MENUST4  LDA DESTDEV
         JSR CLOSE
         JMP MENU


MENURST  CMP #""
         BNE MENUQUIT
         .IF C64
         LDA #$37
         STA $01
         LDA #$08
         STA $DE00
         JMP $FCE2
         .ENDIF

         .IF C128
         LDA #$00  ;BANK15
         STA $FF00
         STA $D030
         LDY #$11
MENURST1 LDA $10EC,Y
         STA $1000,Y
         DEY
         BPL MENURST1
         SEI
         JSR IOINIT
         CLI
         JMP $4000
         .ENDIF


MENUQUIT CMP #"Q"
         BEQ *+5
         JMP MENU

         LDA #9
         JSR CHROUT

         ;CLEANUP?
        ;JSR CLALL

         LDA #$00
         LDX #$08
MENUQUIU STA $68,X
         DEX
         BPL MENUQUIU


         .IF C64
         LDA $01
         ORA #$01
         STA $01
         .ENDIF

         .IF C128
         LDA #$00  ;BANK15
         STA $FF00
         STA $D030
         LDY #$11
FNCTN3   LDA $10EC,Y
         STA $1000,Y
         DEY
         BPL FNCTN3
         .ENDIF


         ;SCPU DEOPTIMIZE
         ;STA $D07E
         ;STA $D077
         ;STA $D07F

         RTS



SLCT
         LDA #$24     ;$
         STA IOTEXT
         LDX #0
         LDY #1
SLCT1A   CPX ZIPPATHL
         BEQ SLCT1B
         LDA ZIPPATH,X
         STA IOTEXT,Y
         INX
         INY
         BPL SLCT1A
SLCT1B   LDA #$2A     ;*
         STA IOTEXT,Y
         INY
         LDX SRCDEV

         STY IOTEMP
         LDA #$01
         LDY #$00
         JSR SETLFS

         LDA IOTEMP
         LDX #<IOTEXT
         LDY #>IOTEXT
         JSR SETNAM
         JSR OPEN

         JSR READST
         BEQ *+3
         RTS

         LDX #$01
         JSR CHKIN

         JSR CHRIN
         JSR CHRIN

SLCTR0   LDA #13
         JSR CHROUT

SLCTR1   LDA #$00
         STA SLCTTMP
         JSR CHRIN
         JSR CHRIN
         JSR CHRIN
         STA IONUM
         JSR CHRIN
         STA IONUM+1
         JSR READST
         BEQ *+5
         JMP SLCTRX  ;??

         LDA IONUM
         ORA IONUM+1
         BNE SLCTR1B
         JMP SLCTR6

SLCTR1B ;PRINT BLOCKS
         LDA #0
         STA IONUM+2
         STA IONUM+3
         JSR IOPRND

SLCTR2   JSR CHRIN  ;"
         BNE *+5
         JMP SLCTRX
         JSR CHROUT
         CMP #$22
         BNE SLCTR2
         LDY #$00
SLCTR3   JSR CHRIN
         BEQ SLCTR0
         JSR CHROUT
         CMP #$22
         BEQ SLCTR4
         STA IOTEXT,Y
         INY
         STY SLCTTMP
         BNE SLCTR3

SLCTR4   JSR CHRIN
         BEQ SLCTR4A
         JSR CHROUT
         BNE SLCTR4

SLCTR4A  LDY SLCTTMP
         DEY
         LDA IOTEXT,Y
         CMP #"Z"
         BEQ SLCTR4D
         CMP #""
         BEQ SLCTR4D
         CMP #"P"
         BEQ SLCTR4B
         CMP #""
         BNE SLCTR47
SLCTR4B  DEY
         LDA IOTEXT,Y
         CMP #"I"
         BEQ SLCTR4C
         CMP #""
         BNE SLCTR47
SLCTR4C  DEY
         LDA IOTEXT,Y
         CMP #"Z"
         BEQ SLCTR5
         CMP #""
         BEQ SLCTR5
         BNE SLCTR47
SLCTR4D  DEY
         LDA IOTEXT,Y
         CMP #"G"
         BEQ SLCTR5
         CMP #""
         BEQ SLCTR5
SLCTR47  JMP SLCTR0

SLCTR5   JSR CLRCHN
         LDX #<SLCTTXT
         LDY #>SLCTTXT
         JSR IOPRINT

SLCTR5A  JSR GETIN
         BEQ SLCTR5A
         CMP #$03     ;RNSTP
         BEQ SLCTRQ
         JSR CHROUT ;
         CMP #"Q"
         BEQ SLCTRQ
         CMP #"Y"
         BEQ SLCTRX
         CMP #$0D
         BEQ SLCTRX
         ;FALLTHROO

         LDA #$0D
         JSR CHROUT
         LDX #$01
         JSR CHKIN
         JMP SLCTR1

SLCTR6  ;SKIP
         JSR CHRIN
         BNE SLCTR6
SLCTR7   JMP SLCTR1
SLCTRQ   LDA #$00
         STA SLCTTMP
SLCTRX   LDA #$01
         JSR CLOSE
         JSR CLRCHN
         LDY SLCTTMP
         RTS

SLCTTMP  .BYTE 0
SLCTTXT  .TEXT " /N/Q "
         .BYTE 0




TXTM1    .TEXT "       " ;-3

         .IF C64
         .TEXT "  NZIP64 V2.15"
         .ENDIF
         .IF C128
         .TEXT "  NZIP128 V2.15"
         .ENDIF

         .BYTE 13
         .TEXT "        RROL "
         .TEXT "MITH () 2000"
         .BYTE 13
         .TEXT "          "
         .TEXT "ERROL@ROS.COM.AU"
         .BYTE 13,13
         .TEXT "F1 HOW SOURCE DIR"
         .BYTE 13
         .TEXT "F2 OURCE DEVICE: "
         .BYTE 0

TXTM2    .BYTE 32,13
         .TEXT " + OURCE PATH  : "
         .BYTE 0

TXTM3    .BYTE 13

         .TEXT " @ OURCE DOS CMD"
         .BYTE 13

         .TEXT "F3 HOW DEST DIR"
         .BYTE 13
         .TEXT "F4 EST DEVICE  : "
         .BYTE 0

TXTM4    .BYTE 32,13
         .TEXT " - EST PATH    : "
         .BYTE 0



TXTM5    .BYTE 13

         .TEXT " * EST DOS CMD"
         .BYTE 13

         .TEXT "F5 IP FILENAME : "
         .BYTE 0


TXTM6    .BYTE 13
         .TEXT "F6 EFAULT TYPE : "
         .BYTE 0

TXTM7    .BYTE 13
         .TEXT "F7 NZIP FILE"
         .BYTE 0

TXTM8    .BYTE 13
         .TEXT " Q UIT "
         .TEXT "(ћ ESET)"
        ;.BYTE 13,13

        ;.IF C64
        ;.TEXT "  AKE YOUR CHOICE:"
        ;.ENDIF

         .IF 0
         .BYTE 159
         .TEXT "  HANKS TO EFF ONES"
         .TEXT " / OADSTAR,"
         .BYTE 13
         .TEXT "  ARREN IBBS & ODD "
         .TEXT "LLIOTT FOR"
         .BYTE 13
         .TEXT "  MAKING THE 128 "
         .TEXT "VERSION POSSIBLE."
         .ENDIF


         .IF 0
         .BYTE 28
         .TEXT ": HIS PROGRAM IS"
         .TEXT " STILL IN"
         .BYTE 13
         .TEXT "DEVELOPMENT AND IS NOT "
         .TEXT "FOR PUBLIC"
         .BYTE 13
         .TEXT "DISTRIBUTION - THANKYOU"
         .ENDIF

         .BYTE 13,13,5,0

TXTMA    .TEXT "YPE ZIP/GZ FILENAME"
         .TEXT " OR RETURN FOR LIST"
         .BYTE 13
         .TEXT ">"
         .BYTE 0

TXTMB    .TEXT "EW ZIP PATH     : "
         .BYTE 0

TXTMC    .TEXT "EW OUTPUT PATH  : "
         .BYTE 0

TXTMD    .TEXT "> "
         .BYTE 0


         .IF C128
PFK128   .BYTE 1,1,1,1,1,1,1,1,0,0
         .BYTE 133,137,134,138
         .BYTE 135,139,136,140
         .ENDIF



UNZIP    LDA SRCDEV
         TAX
         LDY #$0F
         JSR SETLFS

         LDA #0
         JSR SETNAM
         JSR OPEN

         LDA DESTDEV
         CMP SRCDEV
         BEQ UNZIP0
         TAX
         LDY #$0F
         JSR SETLFS

         LDA #0
         JSR SETNAM
         JSR OPEN


UNZIP0   LDA #$01
         LDX SRCDEV
         LDY #$02
         JSR SETLFS

         LDX #$00
         LDY ZIPPATHL
UNZIP1   LDA ZIPNAME,X
         STA ZIPPATH,Y
         INY
         INX
         CPX ZIPNAMEL
         BNE UNZIP1
         TYA

         ;LDA ZIPNAMEL
         LDX #<ZIPPATH ;NAME
         LDY #>ZIPPATH ;NAME
         JSR SETNAM
         JSR OPEN


         LDX SRCDEV
         JSR IOERROR
         BEQ UNZIP2

         LDX #<IOTEXT
         LDY #>IOTEXT
         JSR IOPRINT
         JSR CLALL
         RTS

UNZIP2   JSR INCHRINI
         LDA #$00
         STA UNZIPALL
         STA DATDES
         STA REPLALL


LOOP1    LDA #$0D
         JSR CHROUT
         LDA #$05
         JSR CHROUT

LOOP1A   JSR GETIN
         CMP #$03
         BEQ ENDLOOP1

         JSR INCHR
         BCS ENDLOOP1 ;EOF

LOOP1B   CMP #$50       ;P
         BEQ LOOP1B0

         CMP #$1F
         BNE LOOP1A
        ;STA GZID1
         JSR INCHR
         CMP #$8B
         BNE LOOP1B
        ;STA GZID2
         JSR INCHR
         CMP #$08
         BNE LOOP1B
        ;STA GZCM
         JMP UNGZIP


LOOP1B0 ;STA SIG

         JSR INCHR
         CMP #$4B       ;K
         BNE LOOP1B
        ;STA SIG+1

         JSR INCHR
         CMP #$03
         BEQ LOOP1C
         CMP #$01
         BEQ LOOP1C
         CMP #$05
         BNE LOOP1B
LOOP1C   STA SIG+2

         JSR INCHR
        ;STA SIG+3

         CMP #$04
         BNE LOOP1D
         LDA #$03
         CMP SIG+2
         BNE LOOP1B
         JMP FILEHEAD

LOOP1D   CMP #$02
         BNE LOOP1E
         LDA #$01
         CMP SIG+2
         BNE LOOP1B
         JMP CENTHEAD

LOOP1E   CMP #$06
         BNE LOOP1B
         LDA #$05
         CMP SIG+2
         BNE LOOP1B
         JMP ENDCHEAD


ENDLOOP1 LDA #$01
         JSR CLOSE

         LDA SRCDEV
         JSR CLOSE

         LDA DESTDEV
         CMP SRCDEV
         BEQ ENDLOOP2
         JSR CLOSE

ENDLOOP2 LDX #<TXTDONE
         LDY #>TXTDONE
         JSR IOPRINT

         RTS



DOFILE   LDA FILETYPD
         STA FILETYPE

         JSR SHOWNAME

         LDA UNZIPALL
         BEQ *+5
         JMP DOFILEB

         JSR YNQA
         BMI *+4
         BNE *+3
         RTS

         LDA FILETYPE
         CMP #"9"
         BCS DOFILEB    ;>=9 ?

         JSR DSTDRIVE

DOFILE7  LDA FILETYPE
         LDX #<TXTD64
         LDY #>TXTD64
         CMP #"6"
         BEQ DOFILE7A
         LDX #<TXTD71
         LDY #>TXTD71
         CMP #"7"
         BEQ DOFILE7A
         LDX #<TXTD81
         LDY #>TXTD81
         CMP #"8"
         BEQ DOFILE7A
DOFILE7A JSR IOPRINT
         LDX #<TXTD640
         LDY #>TXTD640
         JSR IOPRINT
         LDA DESTDEV
         STA IONUM
         JSR IOPRND
         LDA DRIVE
         BEQ DOFILE8
         LDA #","
         JSR CHROUT
         LDX #<DRIVE
         LDY #>DRIVE
         JSR IOPRINT
DOFILE8  LDX #<TXTD641
         LDY #>TXTD641
         JSR IOPRINT

DOFILE9  JSR GETIN
         BEQ DOFILE9
         JSR CHROUT
         CMP #$0D
         BEQ DOFILEA
         CMP #"Y"
         BEQ DOFILEA
         CMP #""
         BEQ DOFILEA
         LDA #$0D
         JSR CHROUT
         JMP DOFILE

DOFILEA  LDA #$0D
         JSR CHROUT
DOFILEB  JSR FILEOPEN
         BCS DOREPL

DOFILEX  LDA METHOD
         BNE DOFILEX8

         LDX #<TXTUNSTG
         LDY #>TXTUNSTG
         JMP DOFILEXX

DOFILEX8 LDX #<TXTINFLG
         LDY #>TXTINFLG

DOFILEXX JSR IOPRINT
         LDA #$01
         RTS

DOREPL   LDA IOERRNUM
         CMP #$3F ;FILEEXISTS
         BEQ DOREPL1
         LDA #$00
         STA UNZIPALL
         JMP DOFILE
DOREPL1  LDA REPLALL
         BMI DOREPLS
         BNE DOREPLA
         LDX #<TXTREPL
         LDY #>TXTREPL
         JSR IOPRINT
DOREPL2  JSR GETIN
         BEQ DOREPL2
         CMP #"Y"
         BEQ DOREPLA
         CMP #"Q"
         BEQ DOREPLX
         CMP #"A"
         BNE DOREPL3
         STA REPLALL
         BEQ DOREPLA
DOREPL3  CMP #"O"
         BNE DOREPL4
         DEC REPLALL
DOREPL4  CMP #"R"
         BNE DOREPLS
         JSR RENAME
         BNE DOREPLA
         BEQ DOREPL1
DOREPLS  LDA #$00   ;SKIP
         RTS
DOREPLX  LDA #$FF   ;QUIT
         RTS
DOREPLA  LDX #<TXTREPLD
         LDY #>TXTREPLD
         JSR IOPRINT

         LDX DESTDEV
         JSR CHKOUT
         LDA #"S"
         JSR CHROUT

         LDY #0
DOREPLA1 CPY FILEPTHL
         BEQ DOREPLA2
         LDA FILEPTH,Y
         JSR CHROUT
         INY
         BNE DOREPLA1

DOREPLA2 LDY #$00
DOREPLA3 LDA FILENAME,Y
         JSR CHROUT
         INY
         CPY #$10
         BEQ DOREPLA4
         CPY FLEN
         BNE DOREPLA3

DOREPLA4 LDA #$0D   ;ENTER
         JSR CHROUT
         JSR CLRCHN

         LDX DESTDEV
         JSR IOERROR
         JMP DOFILEA



SRCDRIVE LDX #0
         BNE *+4
DSTDRIVE ;GET DEST PARTITION#
         LDX #FILEPTH-ZIPPATH
         LDY #$00
DSTDRIV0 LDA #$00
         STA DRIVE,Y
         LDA ZIPPATH,X
         CMP #$30
         BCC DSTDRIV1
         CMP #$3A
         BCS DSTDRIV1
         STA DRIVE,Y
         INX
         INY
         CPY #$03
         BNE DSTDRIV0
DSTDRIV1 RTS

;RENAME OUTPUT FILE
;BEQ NO CHANGE
;BNE NEW NAME
RENAME   LDX #<TXTREN
         LDY #>TXTREN
         JSR IOPRINT
         JSR IOINPUT
         LDA #$0D
         JSR CHROUT
         CPY #$00
         BNE *+3
         RTS
         STY FLEN
RENAMEB  LDA IOTEXT,Y
         STA FILENAME,Y
         DEY
         BPL RENAMEB
         RTS

;PRINT OUTPUT FILENAME
SHOWNAME LDA #$05
         JSR CHROUT
         LDX #$00
SHOWNA4  LDA FILENAME,X
         JSR CHROUT
         INX
         CPX #$10
         BNE SHOWNA5
         LDA #$9B       ;LTGREY
         JSR CHROUT
SHOWNA5  CPX FLEN
         BNE SHOWNA4
         LDA #$20
         JSR CHROUT
         LDA #$99       ;LTGREEN
         JSR CHROUT
         RTS


TXTD64   .BYTE 13
         .TEXT "D64"
         .BYTE 0
TXTD71   .BYTE 13
         .TEXT "D71"
         .BYTE 0
TXTD81   .BYTE 13
         .TEXT "D81"
         .BYTE 0

TXTD640  .TEXT " IMAGE WRITE TO DRIVE #"
         .BYTE 0

TXTD641  .TEXT " /N?"
         .BYTE 0

TXTREPL  .TEXT "EPLACE? [ESO"
         .TEXT "LLONEENAME"
         .TEXT "UIT]"
         .BYTE 13,0

TXTREPLD .TEXT "EPLACED.. "
         .BYTE 0

TXTREN   .TEXT "EW FILENAME: "
         .BYTE 0




UNGZIP   LDA #$08
         STA METHOD

         LDY #$00
         STY FLEN
UNGZIP3  JSR INCHR
         BCC UNGZIP3A
         JMP UNGZERR ;EOF
UNGZIP3A STA GZFLG,Y
         INY
         CPY #$07
         BNE UNGZIP3

UNGZIP3D LDA GZFLG
         AND #$E0
         BEQ UNGZIP4
         JMP UNGZERR

UNGZIP4  LDA GZFLG
         AND #$04
         BEQ UNGZIP5

         ;XLEN
         JSR INCHR
         STA GZXLEN
         JSR INCHR
         STA GZXLEN+1
UNGZIP4A LDA GZXLEN
         BNE UNGZIP4B
         LDA GZXLEN+1
         BEQ UNGZIP4C
         DEC GZXLEN+1
UNGZIP4B DEC GZXLEN
         JSR INCHR
         JMP UNGZIP4A
UNGZIP4C

UNGZIP5  LDA GZFLG
         AND #$08
         BEQ UNGZIP6

         ;FNAME
         LDY #$00
UNGZIP5A JSR INCHR

         CMP #65
         BCC UNGZIP5B
         CMP #91
         BCS *+6
         ORA #$80
         BNE UNGZIP5B


         ;FIX HIGH PETSCI
         CMP #96
         BCC UNGZIP5B
         SBC #$20

UNGZIP5B STA FILENAME,Y
         CMP #$00
         BEQ UNGZIP5C
         INY
         BNE UNGZIP5A
UNGZIP5C STY FLEN

UNGZIP6  LDA GZFLG
         AND #$10
         BEQ UNGZIP7

         ;COMMENT
UNGZIP6A JSR INCHR
         ;ERRORS?
         CMP #$00
         BNE UNGZIP6A

UNGZIP7  ;CRC16
         LDA GZFLG
         AND #$02
         BEQ UNGZIP8
         JSR INCHR
         JSR INCHR

UNGZIP8  ;CHECK FILENAME
         LDA FLEN
         BNE UNGZIP9

         LDX ZIPNAMEL
UNGZIP8A DEX
         LDA ZIPNAME,X
         CMP #$2E
         BNE UNGZIP8A

         STX FLEN
UNGZIP8B LDA ZIPNAME,X
         STA FILENAME,X
         DEX
         CPX #$FF
         BNE UNGZIP8B





UNGZIP9  JSR DOFILE
         BEQ UNGZEXIT
         BMI UNGZQUIT

         JSR INFLATE

         JSR FILESHUT

         ;CRC
         LDY #$00
UNGZIPA  JSR INCHR
         STA CRC,Y
         INY
         CPY #$08
         BNE UNGZIPA
         JSR CRCCHECK

         ;ISIZE ?

         ;LOOP?

UNGZEXIT JMP LOOP1
UNGZQUIT JMP ENDLOOP1

UNGZERR  LDX #<TXTGZERR
         LDY #>TXTGZERR
         JSR IOPRINT
         JMP UNGZEXIT














FILEHEAD LDY #$00
FL1      JSR INCHR
         STA HEAD,Y
         INY
         CPY #$1A
         BNE FL1
         LDA HEAD+2
         AND #$08
         STA DATDES

         LDA FLEN
         BEQ FGETX

         LDY #$00
FGETF    JSR INCHR

         CMP #65
         BCC FGETF1
         CMP #91
         BCS *+6
         ORA #$80
         BNE FGETF1

        ;FIX HIGH PETSCI
         CMP #96
         BCC FGETF1
         SBC #$20


FGETF1   STA FILENAME,Y
         INY
         CMP #$2F   ; /
         BNE FGETF3
         LDY #$00
FGETF3   DEC FLEN
         BNE FGETF
         STY FLEN


FGETX    LDA XLEN
         BNE FGETX1
         LDA XLEN+1
         BEQ FGET
         DEC XLEN+1
FGETX1   DEC XLEN
         JSR INCHR
         JMP FGETX


FGET     ;NULL NAME
         LDA FLEN
         BNE FGETCHK1
         JMP SKIP0
         ;0 BYTE FILE
FGETCHK1 LDA DATDES
         ORA USIZE
         ORA USIZE+1
         ORA USIZE+2
         ORA USIZE+3
         BNE FGETCHK2
         JMP SKIP0

FGETCHK2 LDA #$00
         STA CS
         STA CS+1
         STA CS+2
         STA CS+3

         LDA METHOD
         BNE FGET8

FGET0    JSR DOFILE
         BEQ SKIP
         BPL FGET0A
         JMP ENDLOOP1

FGET0A   JSR STORE
         JMP ENDFILEH

FGET8    CMP #$08
         BNE SKIPV1

         JSR DOFILE
         BEQ SKIP
         BPL FGET8A
         JMP ENDLOOP1

FGET8A   JSR INFLATE

         LDA DATDES
         BEQ FGET8D
        ;DATA DESCRIPTOR
         LDY #$00
FGET8C   JSR INCHR
         STA HEAD2,Y
         INY
         CPY #$10
         BNE FGET8C

FGET8D   JSR FILESHUT
         JSR CRCCHECK
         JMP ENDFILEH


         ;UNSUPPORTED METHOD
SKIPV1   LDX #<TXTV1
         LDY #>TXTV1
         JSR IOPRINT


SKIP     LDX #<TXTSKIP
         LDY #>TXTSKIP
         JSR IOPRINT

SKIP0
         LDA DATDES
         BEQ SKIP1
         JMP LOOP1 ;DATDES KLUDGE

SKIP1    LDA CSIZE
         BNE SKIP1D
         LDA CSIZE+1
         BNE SKIP1C
         LDA CSIZE+2
         BNE SKIP1B
         LDA CSIZE+3
         BEQ ENDFILEH
SKIP1A   DEC CSIZE+3
SKIP1B   DEC CSIZE+2
SKIP1C   DEC CSIZE+1
SKIP1D   DEC CSIZE
         JSR INCHR
         JMP SKIP1

ENDFILEH JMP LOOP1


YNQA     LDX #<TXTYNQA
         LDY #>TXTYNQA
         JSR IOPRINT
YNQA0    JSR GETIN
         BEQ YNQA0
         CMP #"N"
         BNE YNQA1
         LDA #$00
         BEQ YNQAX
YNQA1    CMP #"Q"
         BNE YNQA2
         LDA #$FF
         BNE YNQAX
YNQA2    CMP #"A"
         BNE YNQA3
         LDA #$01
         STA UNZIPALL
         BNE YNQAX
YNQA3    CMP #"P"
         BNE YNQA4
         STA FILETYPE
         BNE YNQAX
YNQA4    CMP #"S"
         BNE YNQA5
         STA FILETYPE
         BNE YNQAX
YNQA5    CMP #"D"
         BNE YNQA6
         LDA #"6"
YNQA6    CMP #"6"
         BNE YNQA7
         STA FILETYPE
         BNE YNQAX
YNQA7    CMP #"7"
         BNE YNQA8
         STA FILETYPE
         BNE YNQAX
YNQA8    CMP #"8"
         BNE YNQA9
         STA FILETYPE
         BNE YNQAX
YNQA9    CMP #"R"
         BNE YNQAX
         LDA #$0D
         JSR CHROUT
         JSR RENAME
         JSR SHOWNAME
         JMP YNQA
YNQAX    PHA
         LDY #$22
YNQAX1   LDA #$9D
         JSR CHROUT
         LDA #$20
         JSR CHROUT
         LDA #$9D
         JSR CHROUT
         DEY
         BPL YNQAX1
         PLA
         RTS



CENTHEAD
ENDCHEAD LDA #$0F
         STA $D020
         JMP ENDLOOP1





FILEOPEN LDA #$FF
         STA CRC0
         STA CRC1
         STA CRC2
         STA CRC3

         LDA FILETYPE
         CMP #"9"
         BCC FILOPN3 ;<

         LDA #$02
         LDX DESTDEV
         LDY #$03
         JSR SETLFS

         LDY FILEPTHL
         LDX #$00
FILOPN0  LDA FILENAME,X
         STA FILEPTH,Y
         INY
         INX
         CPX #$10
         BEQ FILOPN00
         CPX FLEN
         BNE FILOPN0

FILOPN00 LDA #$2C
         STA FILEPTH,Y
         INY
         LDA FILETYPE
         STA FILEPTH,Y
         INY
         LDA #$2C
         STA FILEPTH,Y
         INY
         LDA #$57
         STA FILEPTH,Y
         INY
         TYA
         LDX #<FILEPTH
         LDY #>FILEPTH
         JSR SETNAM

         JSR OPEN

         ;ERRORS

         LDX DESTDEV
         JSR IOERROR
         BEQ FILOPN2

         LDA #$02
         JSR CLOSE

FILOPN1  LDX #<IOTEXT
         LDY #>IOTEXT
         JSR IOPRINT
         LDA #$0D
         JSR CHROUT

         SEC
         RTS

FILOPN2  CLC
         RTS

FILOPN3  LDX #$01
         STX TRACK
         DEX
         STX SECTOR


         ;ADD U0>M0 CMD HERE? 128?
FILOPN4
         LDX DESTDEV
         JSR DRVPART ;SET PARTITION
         BCS FILOPN1

         ;RESET 1541 BUFFER POINTER

         LDA #$02
         LDX DESTDEV
         LDY #$03
         JSR SETLFS
         LDA #$01
         LDX #<HASH
         LDY #>HASH
         JSR SETNAM
         JSR OPEN

        ;JSR CLRCHN
         LDX DESTDEV
         JSR CHKOUT
         LDA #66    ;B
         JSR CHROUT
         LDA #45    ;-
         JSR CHROUT
         LDA #80    ;P
         JSR CHROUT
         LDA #58    ;:
         JSR CHROUT
         LDA #51    ;CHANNEL 3
         JSR CHROUT
         LDA #44    ;,
         JSR CHROUT
         LDA #48    ;BYTE 0
         JSR CHROUT
         JSR CLRCHN
         CLC
         RTS



DRVPART ;X=DEVICE,DRIVE SETUP
        ;SEND PARTITION CMD?
         LDA DRIVE
         BEQ DRVPAR1  ;NO PART#
         CMP #"0"
         BEQ DRVPAR1  ;0:

         STX DRVPAR0+1
         ;LDX DESTDEV
         JSR CHKOUT
         LDA #67    ;C
         JSR CHROUT
         LDA #80    ;P
         JSR CHROUT
         LDA DRIVE  ;;
         JSR CHROUT
         LDA DRIVE+1
         BEQ *+5
         JSR CHROUT
         LDA DRIVE+2
         BEQ *+5
         JSR CHROUT

         LDA #$0D
         JSR CHROUT

         JSR CLRCHN

        ;READ ERROR CH
DRVPAR0  LDX #0        ;SELFMOD
         JSR IOERROR
        ;CHECK NOT OK OR SYNTAX?
         CMP #20
         BCC DRVPAR1  ;<20=NO ERROR
         CMP #$1F     ;OR SYNTAX
         BEQ DRVPAR1
         SEC
         RTS
DRVPAR1  CLC
         RTS




FILESHUT LDA #$02
         JSR CLOSE
         LDA FILETYPE
         CMP #"9"
         BCS FILESHUX ;>=
         LDX DESTDEV
         JSR CHKOUT
         LDA #"I"    ;INITIALIZE
         JSR CHROUT
         ;LDA #$0D
         ;JSR CHROUT
         JSR CLRCHN
FILESHUX RTS

CRCCHECK LDA CRC0
         EOR #$FF
         CMP CRC
         BNE CRCCHEC0
         LDA CRC1
         EOR #$FF
         CMP CRC+1
         BNE CRCCHEC0
         LDA CRC2
         EOR #$FF
         CMP CRC+2
         BNE CRCCHEC0
         LDA CRC3
         EOR #$FF
         CMP CRC+3
         BNE CRCCHEC0
         LDX #<TXTCRCOK
         LDY #>TXTCRCOK
         JSR IOPRINT
         RTS
CRCCHEC0 LDX #<TXTCRCER
         LDY #>TXTCRCER
         JSR IOPRINT
         RTS


STORE    LDA #$00
         STA TURBO
         STA SLIDE
         LDA #SLIDEBEG
         STA SLIDE+1

STOR1    LDA DATDES
         BNE STOR2

         LDA CS
         CMP CSIZE
         BNE STOR2

         LDA CS+1
         CMP CSIZE+1
         BNE STOR2

         LDA CS+2
         CMP CSIZE+2
         BNE STOR2

         LDA CS+3
         CMP CSIZE+3
         BEQ STOREX

STOR2    JSR INCHR
         BCS STOREX
         LDY #$00
         STA (SLIDE),Y

         LDY DATDES
         BEQ STOR4
         JMP STORZ

STOR4    INC SLIDE
         BNE STOR5
         INC SLIDE+1
         LDA #SLIDEEND
         CMP SLIDE+1
         BNE STOR5

         LDA #$F0
         STA SLIDE
         DEC SLIDE+1
         JSR FLUSH
         LDA #SLIDEBEG
         STA SLIDE+1
         LDY #$00
         STY SLIDE
STOR4A   LDA (SLIDEC),Y
         STA (SLIDE),Y
         INY
         CPY #$10
         BNE STOR4A
         STY SLIDE

STOR5    INC CS
         BNE STOR1
         INC CS+1
         BNE STOR1
         INC CS+2
         BNE STOR1
         INC CS+3
         BNE STOR1

STOREX   JSR FLUSH
STOREX0  JSR FILESHUT
         JSR CRCCHECK
         RTS

STORZ    CMP #$08
         BEQ STORZ1
STORZ0   JMP STOR4

STORZ1   LDA #$04
         JSR INCHRST
         LDY #$00
STORZ2   JSR INCHR
         STA SIG,Y
         INY
         CPY #$04
         BNE STORZ2

         LDA SIG
         CMP #$50
         BNE STORZ0
         LDA SIG+1
         CMP #$4B
         BNE STORZ0
         LDX SIG+2
         INX
         CPX SIG+3
         BNE STORZ0

         ;DD!

         LDA SLIDE
         SEC
         SBC #$03 ;$0F?
         STA SLIDE
         BCS STORZ5
         LDY SLIDE+1
         CPY #SLIDEBEG
         BNE STORZ4
         LDY #SLIDEEND
STORZ4   DEY
         STY SLIDE+1

STORZ5   ;CRC/LENGTH?
         LDY #$00
STORZ6   JSR INCHR
         STA CRC,Y
         INY
         CPY #$0C
         BNE STORZ6
         JMP STOREX




INFLATE  LDA #$FF
         STA TURBO
         JSR TURBOON

         LDA #$00
         STA BP
         STA BFINAL
         STA SLIDE
         LDA #SLIDEBEG
         STA SLIDE+1

INF0     LDX #$01
         JSR READBITS
         STA BFINAL
         LDX #$02
         JSR READBITS
         BNE INFFIXED

         ;STORED BLOCK
         DEC $D020

         JSR INCHR
         STA LEN
         JSR INCHR
         STA LEN+1
         JSR INCHR
         JSR INCHR
         ;1S COMPLIMENT

INFSTOR0 LDA LEN
         BNE INFSTOR2
         LDA LEN+1
         BNE INFSTOR1
         STA BP        ;FIX READBITS
         STA $D020
         JMP INFLOOP
INFSTOR1 DEC LEN+1
INFSTOR2 DEC LEN
         JSR INCHR
         LDY #$00
         STA (SLIDE),Y
         INC SLIDE
         BNE INFSTOR0
         INC SLIDE+1
         LDA #SLIDEEND
         CMP SLIDE+1
         BNE INFSTOR0
         JSR FLUSH
         LDA #SLIDEBEG
         STA SLIDE+1
         BNE INFSTOR0


INFFIXED CMP #$01
         BNE INFDYNAM

        ;LDA #$01
         STA NUMCODES+1
         LDA #$20
         STA NUMCODES

         LDA #<LLTABL
         STA CODETABL
         STA LEN
         LDA #>LLTABL
         STA CODETABL+1
         STA LEN+1
         LDY #$00

         ;LL
         LDA #$08
         LDX #$90
         JSR LENFILL
         LDA #$09
         LDX #$70
         JSR LENFILL
         LDA #$07
         LDX #$18
         JSR LENFILL
         LDA #$08
         LDX #$08
         JSR LENFILL

         ;DIS
         LDA #$05
         LDX #$20
         JSR LENFILL

         LDA #<LLTAB
         STA CODETAB
         LDA #>LLTAB
         STA CODETAB+1

         JSR DOCODE

         LDA #<DISTABL
         STA CODETABL
         LDA #>DISTABL
         STA CODETABL+1
         DEC NUMCODES+1 ;=0
        ;LDA #$20
        ;STA NUMCODES  ;SET FOR LL

         LDA #<DISTAB
         STA CODETAB
         LDA #>DISTAB
         STA CODETAB+1

         JSR DOCODE

         JMP INFL


INFDYNAM LDX #$05
         JSR READBITS
         CLC
         ADC #$01
         STA HLIT
         LDA DEST+1
         ADC #$01
         STA HLIT+1

         LDX #$05
         JSR READBITS
         STA HDIST
         INC HDIST

         LDX #$04
         JSR READBITS
         CLC
         ADC #$04
         STA HCLEN


         LDY #$13
         STY NUMCODES

         LDA #$00
         STA NUMCODES+1

INFDYN1  STA CLTABL,Y
         DEY
         BPL INFDYN1

         STA CLTEMP
INFDYN2  LDX #$03
         JSR READBITS
         LDX CLTEMP
         LDY BORDER,X
         STA CLTABL,Y
         INC CLTEMP
         LDA HCLEN
         CMP CLTEMP
         BNE INFDYN2

         ;DOCLCODES
         LDY #<CLTAB
         STY CODETAB
         LDA #>CLTAB
         STA CODETAB+1

         LDY #<CLTABL
         STY CODETABL
         LDA #>CLTABL
         STA CODETABL+1

         JSR DOCODE


         ;DO ALL CLCODES TO LLTABL

         LDA #<LLTABL
         STA LLP
         LDA #>LLTABL
         STA LLP+1

         CLC
         LDA HLIT
         ADC HDIST
         ADC #<LLTABL
         STA INFTABE
         LDA HLIT+1
         ADC #>LLTABL
         STA INFTABE+1

         JSR INFDYNA


         ;LL CODES

         LDA #<LLTABL
         STA CODETABL
         LDA #>LLTABL
         STA CODETABL+1

         LDA HLIT
         STA NUMCODES
         LDA HLIT+1
         STA NUMCODES+1

         LDA #<LLTAB
         STA CODETAB
         LDA #>LLTAB
         STA CODETAB+1

         JSR DOCODE


         ;DIS CODES

         CLC
         LDA #<LLTABL
         ADC HLIT
         STA CODETABL
         LDA #>LLTABL
         ADC HLIT+1
         STA CODETABL+1

         LDA HDIST
         STA NUMCODES
         LDA #$00
         STA NUMCODES+1

         LDA #<DISTAB
         STA CODETAB
         LDA #>DISTAB
         STA CODETAB+1

         JSR DOCODE







         ;MAIN INFLATE LOOP

INFL     LDA #<LLTAB
         STA LLP
         LDA #>LLTAB
         STA LLP+1
         LDY #$00

INFLNEW0 ASL BP
         BNE *+9     ;
         INC BP
         JSR INCHR
         STA INBYTE
         LSR INBYTE  ;
         BCS INFLNEW1

         INY
         INY
         LDA (LLP),Y
         BPL INFLNEW0
         BMI INFLNEW3

INFLNEW1 LDA (LLP),Y
         TAX
         INY
         LDA (LLP),Y
         STA LLP
         STX LLP+1
         LDY #$00
INFLNEW2 LDA (LLP),Y
         BPL INFLNEW0
INFLNEW3 INY
         AND #$01
         BNE INFL8




        ;LITERAL
INFL5    LDA (LLP),Y
         LDY #$00
         STA (SLIDE),Y
         INC SLIDE
         BNE INFL
         INC SLIDE+1
         LDA #SLIDEEND
         CMP SLIDE+1
         BNE INFL
         JSR FLUSH
         LDA #SLIDEBEG
         STA SLIDE+1
         BNE INFL



INFL8    LDA (LLP),Y
         BNE INFLA
        ;END OF BLOCK
         JMP INFLOOP


        ;LENGTH
INFLA    TAY
         LDA CPLENS,Y
         STA LEN
         LDX #$00
         CPY #29    ;SPECIAL LEN=258
         BNE INFLB
         INX
INFLB    STX LEN+1
         LDX CPLEXT,Y
         BEQ INFLD
         JSR READBITS
         CLC
         ADC LEN
         STA LEN
         BCC INFLD
         INC LEN+1

INFLD   ;DISTANCE

         DEC $D020

         LDA #<DISTAB
         STA LLP
         LDA #>DISTAB
         STA LLP+1
         LDY #$00

INFLDNW0 ASL BP
         BNE *+9      ;
         INC BP
         JSR INCHR
         STA INBYTE
         LSR INBYTE   ;
         BCS INFLDNW1

         INY
         INY
         LDA (LLP),Y
         BPL INFLDNW0
         BMI INFLDNW3

INFLDNW1 LDA (LLP),Y
         TAX
         INY
         LDA (LLP),Y
         STA LLP
         STX LLP+1
         LDY #$00
INFLDNW2 LDA (LLP),Y
         BPL INFLDNW0
INFLDNW3 INY



         LDA (LLP),Y
         TAY
         LDA CPDISTL,Y
         STA TEMP+2     ;DISTANCE
         LDA CPDISTH,Y
         STA TEMP+3     ;DISTANCE+1

         LDX CPDEXT,Y
         BEQ INFLCOPY
         JSR READBITS
         CLC
         ADC TEMP+2     ;DISTANCE
         STA TEMP+2     ;DISTANCE
         LDA DEST+1
         ADC TEMP+3     ;DISTANCE+1
         STA TEMP+3     ;DISTANCE+1

INFLCOPY ;COPY
         LDA SLIDE
         SEC
         SBC TEMP+2     ;DISTANCE
         STA LLP
         LDA SLIDE+1
         SBC TEMP+3     ;DISTANCE+1
         SEC
         SBC #SLIDEBEG
         AND #$7F
         CLC
         ADC #SLIDEBEG
         STA LLP+1

         LDY #$00
INFLCOP1 LDA (LLP),Y
         STA (SLIDE),Y

         INC SLIDE
         BNE INFLCOP2
         INC SLIDE+1
         LDA #SLIDEEND
         CMP SLIDE+1
         BNE INFLCOP2
         JSR FLUSH
         LDA #SLIDEBEG
         STA SLIDE+1
         LDY #$00
         ;STY SLIDE

INFLCOP2 LDA LEN
         BNE INFLCOP3
         DEC LEN+1
INFLCOP3 DEC LEN
         BNE INFLCOP4
         LDA LEN+1
         BNE INFLCOP4

         STA $D020

         JMP INFL

INFLCOP4 INC LLP
         BNE INFLCOP1
         INC LLP+1
         LDA LLP+1
         CMP #SLIDEEND
         BNE INFLCOP1
         LDA #SLIDEBEG
         STA LLP+1
         BNE INFLCOP1



INFLOOP  LDA BFINAL
         BNE *+5
         JMP INF0

         LDA #$00
         STA TURBO
         JSR TURBOOFF

         JSR FLUSH
         RTS






INFDYNA  ;SETUP
        ;LDA #$03
        ;STA $D020

         ;OUTER LOOP

INFDYNB  LDA LLP
         CMP INFTABE
         BCC INFDYNC

         LDA LLP+1
         CMP INFTABE+1
         BCC INFDYNC

         RTS


INFDYNC  LDA #<CLTAB
         STA LEN
         LDA #>CLTAB
         STA LEN+1
INFDNEW0 LDX #$01
         JSR READBITS
         BNE INFDNEW1
         INC LEN
         INC LEN
         BNE INFDNEW2
         INC LEN+1
         BNE INFDNEW2
INFDNEW1 LDY #$00
         LDA (LEN),Y
         TAX
         INY
         LDA (LEN),Y
         STA LEN
         STX LEN+1
INFDNEW2 LDY #$00
         LDA (LEN),Y
         BPL INFDNEW0
         INY
         LDA (LEN),Y



         CMP #$10
         BCS INFDYNJ

         LDY #$00
         STA (LLP),Y
         STA CLTEMP
         INC LLP
         BNE *+4
         INC LLP+1
         BNE INFDYNB


INFDYNJ  CMP #$10
         BNE INFDYNK

         LDX #$02
         JSR READBITS
         CLC
         ADC #$03
         TAX
         LDY #$00
INFDYNJ1 LDA CLTEMP
         STA (LLP),Y
         INC LLP
         BNE *+4
         INC LLP+1
         DEX
         BNE INFDYNJ1
         BEQ INFDYNB



INFDYNK  CMP #$11
         BNE INFDYNL

         LDX #$03
         JSR READBITS
         CLC
         ADC #$03
         TAX
         LDA #$00
         TAY
INFDYNK1 STA (LLP),Y
         INC LLP
         BNE *+4
         INC LLP+1
         DEX
         BNE INFDYNK1
         STA CLTEMP
         JMP INFDYNB


INFDYNL  ;ELSE
         LDX #$07
         JSR READBITS
         CLC
         ADC #$0B
         TAX
         LDA #$00
         TAY
INFDYNL1 STA (LLP),Y
         INC LLP
         BNE *+4
         INC LLP+1
         DEX
         BNE INFDYNL1
         STA CLTEMP
         JMP INFDYNB

         ;THE END..




         ;FILL X BITLENGTHS WITH ACC
LENFILL  STA (LEN),Y
         INY
         BNE *+4
         INC LEN+1
         DEX
         BNE LENFILL
         RTS




         ;CREATE HUFFMAN CODES
         ;FROM BITLENGTHS

DOCODE   ;LDA #$03
         ;STA $D020

         ;CLEAR TREE INDEX TOO?

         LDA CODETAB    ;DEST TREE
         STA TEMP+2    ;LLTREEEND=0
         LDA CODETAB+1
         STA TEMP+3


         LDA #$00      ;CODE=0
         STA CODE
         STA CODE+1

        ;CLEAR START OF TREE
         LDY #$1F
DOCODE4  STA (TEMP+2),Y
         STA LLINDEXL,Y
         DEY
         BPL DOCODE4

         LDA #$01     ;FOR LENGTH=1..
         STA CODELEN


DOCOD40  LDA CODETABL  ;BLEN
         STA LLP
         LDA CODETABL+1
         STA LLP+1

         LDA #$00
         STA NUMCOTMP   ;CODE COUNTER
         STA NUMCOTMP+1



         ;OUTER LOOP (VALUES)
DOCOD41  LDY #$00
        ;USE Y=NUMCOTMP?

         LDA (LLP),Y
         CMP CODELEN    ;LENGTH..
         BEQ DOCOD42
         JMP DOCOD47   ;NOT MATCHED




DOCOD42 ;INNER LOOP INIT

         LDA CODETAB    ;LLTP=0
         STA LEN
         LDA CODETAB+1
         STA LEN+1

         ;LLBP=BIT0
         STY LLBP


         LDX CODELEN    ;START=1ST BIT
         DEX

         ;INNER BITLOOP START

DOCOD43  LDA BITMASKL,X
         AND CODE
         BNE DOCOD44
         LDA BITMASKH,X
         AND CODE+1
         BEQ DOCOD45

         ;BIT=1
DOCOD44
         LDY #$00     ;LLTREE(LLTP)=0?
         LDA (LEN),Y
         INY
         ORA (LEN),Y
         BEQ DOCOD44C

         LDA (LEN),Y  ;LLTP=TREE(LLTP)
         PHA
         DEY
         LDA (LEN),Y
         STA LEN+1
         PLA
         STA LEN
         JMP DOCOD46

DOCOD44C LDY LLBP
         LDA LLINDEXL,Y
         STA LEN
         LDA LLINDEXH,Y
         STA LEN+1
         LDY #$00
         LDA TEMP+3
         STA (LEN),Y
         INY
         LDA TEMP+2
         STA (LEN),Y

         STA LEN        ;LLTP=LLTREND
         LDA TEMP+3
         STA LEN+1

         JMP DOCOD46

        ;BIT =0
DOCOD45  LDY #$00   ;LLTREE(LLTP)=0?
         LDA (LEN),Y
         INY
         ORA (LEN),Y
         BNE DOCOD45C
DOCOD45B LDY LLBP  ;LLINDEX(LLBP)=LLTP
         LDA LEN
         STA LLINDEXL,Y
         LDA LEN+1
         STA LLINDEXH,Y

DOCOD45C LDA LEN       ;LLTP=LLTP+1
         CLC
         ADC #$02
         STA LEN
         BCC DOCOD46
         INC LEN+1


DOCOD46  ;OUTSIDE IF

         LDA LEN+1    ;CMP LLTP,LLTREND
         CMP TEMP+3
         BCC DOCOD46C
         STA TEMP+3

         LDA LEN
         CMP TEMP+2
         BCC DOCOD46C

         ADC #$01    ;LLTREND=LLTP+1
         STA TEMP+2
         BCC DOCOD46B
         INC TEMP+3

DOCOD46B LDA #$00     ;TREE(LLTREND)=0
         TAY
         STA (TEMP+2),Y
         INY
         STA (TEMP+2),Y


DOCOD46C INC LLBP
         DEX          ;NEXT J
         BMI DOCOD46D
         JMP DOCOD43

DOCOD46D LDY #$00
         LDA NUMCOTMP+1
         ORA #$80
         STA (LEN),Y
         LDA NUMCOTMP
         INY
         STA (LEN),Y

         INC CODE
         BNE DOCOD47
         INC CODE+1

DOCOD47 ;NEXT VALUE..

         INC NUMCOTMP
         BNE DOCOD48
         INC NUMCOTMP+1

DOCOD48  LDA NUMCOTMP+1
         CMP NUMCODES+1
         BNE DOCOD49

         LDA NUMCODES
         CMP NUMCOTMP
         BEQ DOCOD50

DOCOD49  INC LLP
         BNE DOCOD4A
         INC LLP+1

DOCOD4A  JMP DOCOD41


DOCOD50  ASL CODE
         ROL CODE+1
         INC CODELEN
         LDA #$10
         CMP CODELEN
         BEQ DOCODEX
         JMP DOCOD40


DOCODEX  ;LDA #$00
         ;STA $D020
         RTS








         ;READ X BITS INTO A, DEST+1
         ;USES A,X,Y
READBITS LDY #$00
         STY DEST+1
         STY DEST
         STY TEMP+1
         INY
         STY TEMP

         CPX #$00   ;SAFETYCHECK
         BEQ RBX

RB0      ASL BP
         BNE RB1

RBB      INC BP      ;BP=1
         STX INBYTE
         JSR INCHR
         LDX INBYTE
         STA INBYTE

RB1      LSR INBYTE
         BCC RB3

         LDA TEMP+1
         BEQ RB2
         ORA DEST+1
         STA DEST+1
         BNE RB3
RB2      LDA TEMP
         ORA DEST
         STA DEST

RB3      ASL TEMP
         ROL TEMP+1
         DEX
         BNE RB0

RBX      LDA DEST
         RTS




         ;FLUSH BUFFER TO FILE
FLUSH
         JSR TURBOOFF
         LDA #$05
         STA $D020

         LDY #$00
         STY SLIDEC
         LDA #SLIDEBEG
         STA SLIDEC+1

FLUSH0   LDX #$02
         JSR CHKOUT

         LDY #0

FLUSH1   CPY SLIDE
         BNE FLUSH2
         LDA SLIDEC+1
         CMP SLIDE+1
         BNE FLUSH2 ;EQ FLUSH3
         JMP FLUSH3

FLUSH2   LDA (SLIDEC),Y
         PHA
         JSR CHROUT
         PLA

         EOR CRC0
         TAX
         LDA CRCT0,X
         EOR CRC1
         STA CRC0
         LDA CRCT1,X
         EOR CRC2
         STA CRC1
         LDA CRCT2,X
         EOR CRC3
         STA CRC2
         LDA CRCT3,X
         STA CRC3

         INY
         BNE FLUSH1

         INC SLIDEC+1
        ;BNE FLUSH1

         LDA FILETYPE
         CMP #"9"
         BCS FLUSH1


         JSR CLRCHN
         LDX DESTDEV
         JSR CHKOUT
         LDA #85    ;U
         JSR CHROUT
         LDA #50    ;2
         JSR CHROUT
         LDA #58    ;:
         JSR CHROUT
         LDA #51    ;CHANNEL 3
         JSR CHROUT
         LDA #44    ;,
         JSR CHROUT

         LDA #48   ;DRIVE 0
         JSR CHROUT

         LDA #44    ;,
         JSR CHROUT
         LDA TRACK
         ASL A
         TAY
         LDA NUMS,Y
         JSR CHROUT
         INY
         LDA NUMS,Y
         CMP #$20
         BEQ *+5
         JSR CHROUT
         LDA #44    ;,
         JSR CHROUT
         LDA SECTOR
         ASL A
         TAY
         LDA NUMS,Y
         JSR CHROUT
         INY
         LDA NUMS,Y
         CMP #$20
         BEQ *+5
         JSR CHROUT

         JSR CLRCHN

         LDY TRACK
         ;LDA SECTOR
         ;CLC
         ;ADC #$01
         ;STA SECTOR

         INC SECTOR
         LDA SECTOR

         LDX FILETYPE
         CPX #"6"
         BNE FLUSH27

FLUSH26  CMP TRACKS,Y
         BEQ FLUSH29
         JMP FLUSH0

FLUSH27  CPX #"7"
         BNE FLUSH28
         CPY #36
         BCC FLUSH26 ;LIKE D64 <36

         CMP TRACKS-35,Y
         BEQ FLUSH29
         JMP FLUSH0



FLUSH28  CMP #40
         BEQ FLUSH29
         JMP FLUSH0

FLUSH29  LDA #$00
         STA SECTOR
         INY
         STY TRACK
         CPY #36
         BEQ *+5
         JMP FLUSH0

         CPX #"7"
         BNE FLUSH2A
         CPY #71
         BEQ FLUSH2B
         JMP FLUSH0


FLUSH2A  CPX #"8"
         BNE FLUSH2B
         CPY #81
         BEQ FLUSH2B
         JMP FLUSH0

        ;DONE
FLUSH2B  LDY #0

FLUSH3   STY SLIDEC

         JSR CLRCHN
         LDA #$00
         STA $D020
         JSR TURBOON
FLUSHX   RTS




TRACK    .BYTE 1
SECTOR   .BYTE 0
DRIVE    .BYTE 0,0,0,0

HASH     .TEXT "#"


NUMS     .TEXT "0 1 2 3 4 5 6 7 8 9 "
         .TEXT "10111213141516171819"
         .TEXT "20212223242526272829"
         .TEXT "30313233343536373839"
         .TEXT "40414243444546474849"
         .TEXT "50515253545556575859"
         .TEXT "60616263646566676869"
         .TEXT "70717273747576777879"
         .TEXT "80"
        ;.TEXT "818283848586878889"
        ;.TEXT "90919293949596979899"

TRACKS   .BYTE 21
         .BYTE 21,21,21,21,21
         .BYTE 21,21,21,21,21
         .BYTE 21,21,21,21,21
         .BYTE 21,21,19,19,19
         .BYTE 19,19,19,19,18
         .BYTE 18,18,18,18,18
         .BYTE 17,17,17,17,17
         .BYTE 17,17,17,17,17

         ;









         ;GET BYTE FROM INPUT BUFFER
         ;A=BYTE,X USED,Y SAVED
INCHR    STY INCHRTMP

         LDY INCHREOF
         BNE INCHR9
INCHR00
         .IF C64
         LDA (INCHRO),Y
         .ENDIF

         .IF C128
         LDA #INCHRO
         LDX #$01
         SEI
         JSR INDFET
         CLI
         .ENDIF

         INC INCHRO
         BEQ INCHR0
         LDY INCHRTMP
         CLC
         RTS

INCHR0   INC INCHRO+1
         LDY INCHRO+1
         CPY INCHRI+1
         BEQ INCHR1
         LDY INCHRTMP
         CLC
         RTS


        ;EOF CHECK
INCHR9   CPY INCHRO+1
         BEQ INCHRA
         LDY #$00
         BEQ INCHR00
INCHRA   SEC
         LDY INCHRTMP
         RTS





INCHR1   LDY INCHREOF
         BNE INCHRA
         PHA
         ;COPY LAST $20 TO START
         STY INCHRI
         LDA #INCHRBEG
         STA INCHRI+1
         LDA #$E0
         STA INCHRO
         DEC INCHRO+1

         .IF C128
         LDX #INCHRI
         STX STAVEC
         .ENDIF
INCHR2
         .IF C64
         LDA (INCHRO),Y
         .ENDIF

         .IF C128
         LDA #INCHRO
         LDX #$01
         SEI
         JSR INDFET
         .ENDIF

         .IF C64
         STA (INCHRI),Y
         .ENDIF

         .IF C128
         LDX #$01
         JSR INDSTA
         CLI
         .ENDIF


         INY
         CPY #$20
         BNE INCHR2

         ;RESET POINTERS
         STY INCHRO
         LDA #INCHRBEG
         STA INCHRO+1

         JSR TURBOOFF

         LDX #$01
         JSR CHKIN


         ;FILL TO END
INCHR3   JSR CHRIN

         .IF C64
         STA (INCHRI),Y
         .ENDIF

         .IF C128
         LDX #$01
         SEI
         JSR INDSTA
         CLI
         .ENDIF

         INY
         BNE INCHR3
         INC INCHRI+1

         ;CHECK EOF
         JSR READST
         BEQ INCHR4

         LDA INCHRI+1
         STA INCHREOF
         BNE INCHR5

INCHR4   LDA INCHRI+1
         CMP #INCHREND
         BNE INCHR3

INCHR5   JSR CLRCHN

         JSR TURBOON

         PLA
         LDY INCHRTMP
         CLC
         RTS


         ;RESET BACK  BYTES
INCHRST  STA INCHRTMP
         SEC
         LDA INCHRO
         SBC INCHRTMP
         STA INCHRO
         BCS INCHRST1
         DEC INCHRO+1
INCHRST1 RTS


         ;INIT INPUT BUFFER
INCHRINI
         ;JSR CLRCHN
         LDX #$01
         JSR CHKIN


         LDY #INCHREND
         STY INCHRI+1
         DEY
         STY INCHRO+1
         LDY #$00
         STY INCHRI
         STY INCHRO

         .IF C128
         LDX #INCHRO
         STX STAVEC
         .ENDIF

INCHRIN2 JSR CHRIN

         .IF C64
         STA (INCHRO),Y
         .ENDIF

         .IF C128
         LDX #$01
         SEI
         JSR INDSTA
         CLI
         .ENDIF

         INY
         BNE INCHRIN2
         STY INCHREOF
         JSR CLRCHN
         RTS




TURBOON  LDA TURBO
         BEQ TURBOOFF
         LDA $D011
         AND #$6F
         STA $D011
         LDA #$FD
         STA $D030
         RTS

TURBOOFF LDA $D011
         ORA #$10
         AND #$7F
         STA $D011

         ;.IF C128
         ;LDA MODE
         ;BEQ *+3
         ;RTS
         ;.ENDIF

         LDA #$00
         STA $D030
         RTS




;INFLATE STUFF
CPLENS   .BYTE 0
         .BYTE 3,4,5,6,7,8,9,10
         .BYTE 11,13,15,17,19,23,27,31
         .BYTE 35,43,51,59,67,83,99,115
         .BYTE 131,163,195,227,2,0,0
CPLEXT   .BYTE 0
         .BYTE 0,0,0,0,0,0,0,0
         .BYTE 1,1,1,1,2,2,2,2
         .BYTE 3,3,3,3,4,4,4,4
         .BYTE 5,5,5,5,0,0,0

CPDISTL  .BYTE 1,2,3,4,5,7,9,13
         .BYTE 17,25,33,49
         .BYTE 65,97,129,193
         .BYTE 1,129,1,1
         .BYTE 1,1,1,1
         .BYTE 1,1,1,1
         .BYTE 1,1,0,0
CPDISTH  .BYTE 0,0,0,0,0,0,0,0
         .BYTE 0,0,0,0
         .BYTE 0,0,0,0
         .BYTE 1,1,2,3
         .BYTE 4,6,8,12
         .BYTE 16,24,32,48
         .BYTE 64,96,0,0

CPDEXT   .BYTE 0,0,0,0,1,1,2,2
         .BYTE 3,3,4,4,5,5,6,6
         .BYTE 7,7,8,8,9,9,10,10
         .BYTE 11,11,12,12,13,13,0,0

BORDER   .BYTE 16,17,18,0,8,7,9,6
         .BYTE 10,5,11,4,12,3,13,2
         .BYTE 14,1,15,0

BITMASKH .BYTE 0,0,0,0,0,0,0,0
BITMASKL .BYTE 1,2,4,8,16,32,64,128
         .BYTE 0,0,0,0,0,0,0,0
         .BYTE 0


TXTUNSTG .TEXT "UNSTORING "
         .BYTE 0
TXTINFLG .TEXT "INFLATING "
         .BYTE 0
TXTCRCOK .TEXT ""
         .BYTE 0
TXTCRCER .TEXT " ERROR!"
         .BYTE 0
TXTGZERR .TEXT "GZIP ERROR!"
         .BYTE 13,0

TXTSKIP  .TEXT "SKIPPING"
         .BYTE 0
TXTV1    .TEXT "UNSUPPORTED!"
         .BYTE 0
TXTYNQA  .TEXT "[ESOUITLL"
         .TEXT "ENAMERGEQ"
         .TEXT "64D71D81]"
         .BYTE 0

TXTDONE  .BYTE $0D
         .TEXT "DONE!  "
         .BYTE 0

TURBO    .BYTE 0

FILETYPD .BYTE $50 ;P
FILETYPE .BYTE $50

SRCDEV   .BYTE 8
DESTDEV  .BYTE 8

ZIPPATHL .BYTE 2
FILEPTHL .BYTE 2
ZIPNAMEL .BYTE 8  ;DONT TOUCH BELOW!
ZIPNAME  .TEXT "A.ZIP               "
         .WORD 0
ZIPPATH  .TEXT "0:                  "
         .TEXT "                    "
         .WORD 0
FILEPTH  .TEXT "0:                  "
         .TEXT "                    "
         .TEXT "                    "
         .WORD 0






         ;SHOW DIRECTORY X=DEVICE
IODIR    STY IOTEMP
         LDA #$01
        ;LDX #$08
         LDY #$00
         JSR SETLFS

         LDA IOTEMP
         LDX #<IOTEXT
         LDY #>IOTEXT
         JSR SETNAM
         JSR OPEN

         JSR READST
         BEQ *+3
         RTS

         LDX #$01
         JSR CHKIN

         JSR CHRIN
         JSR CHRIN

IODIR0   LDA #13
         JSR CHROUT

         ;PAUSE IF KEY
         JSR CLRCHN
         JSR GETIN
         BEQ IODIR1
         CMP #$03     ;RNSTP
         BEQ IODIRX
         JSR IOPAUSE

IODIR1   LDX #$01
         JSR CHKIN

         JSR CHRIN
         JSR CHRIN
         JSR CHRIN
         STA IONUM
         JSR CHRIN
         STA IONUM+1
         JSR READST
         BNE IODIRX

         ;PRINT BLOCKS
         LDA #0
         STA IONUM+2
         STA IONUM+3
         JSR IOPRND

         LDA #32
         JSR CHROUT

IODIR2   JSR CHRIN
         BEQ IODIR0
         JSR CHROUT
         BNE IODIR2

IODIRX   LDA #$01
         JSR CLOSE
         JSR CLRCHN
         JSR IOPAUSE
         RTS


         ;READ ERROR CHANNEL FROM DEV 
         ;ERROR# IN IOERRNUM, TEXT IN
         ;IOTEXT
;IOERROR  LDA #$0F
        ;;LDX #$08
        ;LDY #$0F
        ;JSR SETLFS

        ;LDA #0
        ;JSR SETNAM
        ;JSR OPEN

IOERROR  ;STX IOTEMP
         ;JSR CLRCHN
         ;LDX IOTEMP
         JSR CHKIN

         LDY #$00
IOERROR0 JSR CHRIN
         CMP #13
         BEQ IOERROR1
         STA IOTEXT,Y
         INY
         BNE IOERROR0

IOERROR1 LDA #$00
         STA IOTEXT,Y
         ;CALC ERROR#
         LDA IOTEXT
         SEC
         SBC #48
         ASL A
         STA IOTEMP
         ASL A
         ASL A
         CLC
         ADC IOTEMP
         STA IOERRNUM
         LDA IOTEXT+1
         SEC
         SBC #48
         CLC
         ADC IOERRNUM
         STA IOERRNUM

         JSR CLRCHN

         ;LDA #$0F
         ;JSR CLOSE
         LDA IOERRNUM
         RTS



         ;PING DEVICE 
         ;CC NEGATIVE IF NO DEVICE
IOPING   LDA #$0F
         TAY
         JSR SETLFS

         LDA #0
         JSR SETNAM
         JSR OPEN
         LDA #$0F
         JSR CLOSE
         JSR READST
         RTS



         ;PRINT DECIMAL NUMBER IN
         ;IONUM TO IONUM+3
IOPRND   LDA #10
         STA IONUM+4

         LDY #10
IOPRND1  STY IOTEMP
         JSR IODIV32
         LDY IOTEMP
         CLC
         ADC #48
         STA IOTMPC,Y
         DEY
         BNE IOPRND1

IOPRND2  INY
         LDA IOTMPC,Y
         CMP #48
         BEQ IOPRND2
         CPY #11
         BNE IOPRND3
         LDA #48
         JSR CHROUT
         RTS
IOPRND3  JSR CHROUT
         INY
         LDA IOTMPC,Y
         CPY #11
         BNE IOPRND3
         RTS



         ;DIVIDE IONUM - IONUM+3 BY
         ;IONUM+4 REMAINDER IN A
IODIV32  LDA #0
         LDY #$20
IODIV321 ASL IONUM
         ROL IONUM+1
         ROL IONUM+2
         ROL IONUM+3
         ROL A
         CMP IONUM+4
         BCC IODIV322
         SBC IONUM+4
         INC IONUM
IODIV322 DEY
         BNE IODIV321
         RTS



         ;INPUT TEXT
         ;RETURN STRING IN IOTEXT
         ;Y = LENGTH
IOINPUT  LDY #$00
         STY BLNSW     ;BLINK ON

         .IF C128
         LDA #$0A
         STA $D600
         BIT $D600
         BPL *-3
         LDA CURMOD ;80COL CURSOR
         STA $D601
         .ENDIF

IOINPUT1 STY IOTEMP
         JSR GETIN
         LDY IOTEMP
         CMP #0
         BEQ IOINPUT1
         CMP #13
         BEQ IOINPUTX
         CMP #20
         BNE IOINPUT2
         CPY #0
         BEQ IOINPUT1
         JSR CHROUT
         DEY
         BPL IOINPUT1

IOINPUT2 CMP #32
         BCC IOINPUT1
         CMP #192
         BCS IOINPUT3
         CMP #128
         BCS IOINPUT1

IOINPUT3 STA IOTEXT,Y
         JSR CHROUT
         INY
         CPY #20
         BNE IOINPUT1

IOINPUTX LDA #0
         STA IOTEXT,Y
         STA BLNON
         LDA #32
         STA BLNSW   ;BLINK OFF
         JSR CHROUT  ;OVERWRITE CURSOR

        ;128 80COL OFF
         .IF C128
         LDA #$0A
         STA $D600
         BIT $D600
         BPL *-3
         LDA #$20 ;NO CURSOR
         STA $D601
         .ENDIF

         RTS



IOPRINT  ;PRINT WHATS AT YYXX
         ;0 TERMINATED
         STX IOZP
         STY IOZP+1
         LDY #0
IOPRINT1 LDA (IOZP),Y
         BEQ IOPRINTX
         JSR CHROUT
         INY
         BNE IOPRINT1
IOPRINTX RTS



         ;WAIT FOR KEY WITH PROMPT
IOPAUSE  LDX #<IOPAUSET
         LDY #>IOPAUSET
         JSR IOPRINT
IOPAUSE1 JSR GETIN
         BEQ IOPAUSE1
         LDX #<IOPAUSEU
         LDY #>IOPAUSEU
         JSR IOPRINT
         RTS



IODOLLAR .TEXT "$"
IOPAUSET .TEXT "- PAUSE -"
         .BYTE 0
;IOPAUSEU .TEXT ""
IOPAUSEU .TEXT ""
         .BYTE 0

IONUM    .WORD 0,0,0
IOERRNUM .BYTE 0
IOTEMP   .WORD 0,0
IOTMPC   .WORD 0,0,0,0,0,0
IOTEXT   .TEXT "STROBE2000          "
         .TEXT "                    "


FILENAME .TEXT "                    "
         .TEXT "                    "



;ZIP STUFF (& GZIP)

SIG      .BYTE 0,0,0,0

HEAD     .BYTE 0,0,0,0
METHOD   .BYTE 0,0
HEAD2    .BYTE 0,0,0,0
CRC      .BYTE 0,0,0,0
CSIZE    .BYTE 0,0,0,0
USIZE    .BYTE 0,0,0,0
FLEN     .BYTE 0,0
XLEN     .BYTE 0,0

CS       .BYTE 0,0,0,0
;DEST.BYTE 0,0
;TEMP.BYTE 0,0
;BP.BYTE 0
;INBYTE.BYTE 0
;ZIPEOF   .BYTE 0
UNZIPALL .BYTE 0
REPLALL  .BYTE 0

DATDES   .BYTE 0
;INCHRI   .BYTE 0
;INCHRO   .BYTE 0
INCHREOF .BYTE 0



;GZIP STUFF

;GZID1    .BYTE 0
;GZID2    .BYTE 0
;GZCM     .BYTE 0
GZFLG    .BYTE 0
GZMTIME  .WORD 0,0
GZXFL    .BYTE 0
GZOS     .BYTE 0

GZXLEN   .WORD 0

GZCRC    .WORD 0,0
GZISIZE  .WORD 0,0





BFINAL   .BYTE 0
;COUNT    .BYTE 0,0


;LENGTH   .WORD 0
DISTANCE .WORD 0


INFTABE  .WORD 0


HLIT     .WORD 0
HDIST    .BYTE 0
HCLEN    .BYTE 0
CLTEMP   .BYTE 0

NUMCODES .WORD 0
NUMCOTMP .WORD 0
CODETAB  .WORD 0
CODE     .WORD 0

MAXBIT   .BYTE 0

CODELEN  .BYTE 0

LLINDEXL .WORD 0,0,0,0,0,0,0,0
LLINDEXH .WORD 0,0,0,0,0,0,0,0

CODETABL .WORD 0
LLBP     .BYTE 0

         ;ERROR CHECKING EVERWHERE!
         ;Q/S FOR UNSUPPORTED
         ;GZIP FILE LEN CHECKING!
         ;

